// C Source File
// Created 8/18/2001; 9:16:02 PM
//if chosen lines
#include "declerations.h"
enum {STD = 1, MXB};
void linehand (int result)
{
	int stringlength, top, bottom, width,
		extrawidth = 0, size;
	HANDLE dialoghandle = H_NULL;
	char rawvalues[80] = {};
	char* x1value, *x2value, *y1value, *y2value, *avalue, *bvalue, *cvalue;
	unsigned char rpn[100] = {};
	ESI ptr;
	int lcd_width = LCD_WIDTH, ti92plus = TI92PLUS;
	WinClr (DeskTop);
	FontSetSys (F_6x8);
	if (ti92plus)
	{
		extrawidth = 10;
	}
	if (result != CONVERT)
	{
		stringlength = DrawStrWidth ("(x1,y1), (x2,y2)", F_6x8);
		DrawStr ((lcd_width - stringlength)/2, 20, "(x1,y1), (x2,y2)", A_REPLACE);
		dialoghandle = DialogNewSimple (155 + 2 * extrawidth, 47 + extrawidth); 
		DialogAddTitle (dialoghandle, "Enter values", BT_OK, BT_CANCEL);
		DialogAddRequest (dialoghandle, 3, 14, "x1=", 0, 19, 8);
		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus, "y1=", 20, 19, 8);
		DialogAddRequest (dialoghandle, 70 + extrawidth, 14, "x2=", 40, 19, 8);
		DialogAddRequest (dialoghandle, 70 + extrawidth, 24 + 2 * ti92plus, "y2=",
			60, 19, 8);
	}
	switch (result)
	{
	case (SLOPE):
		if (DialogDo (dialoghandle, CENTER, 30 + 2 * ti92plus, rawvalues, NULL)
			== KEY_ENTER)
		{
			x1value = rawvalues;
			y1value = rawvalues + 20;
			x2value = rawvalues + 40;
			y2value = rawvalues + 60;
			HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  		push_parse_text (x1value);
  		push_internal_simplify (top_estack);
  		ptr = top_estack;
  		push_parse_text (x1value);
  		push_internal_simplify (top_estack);
			if (!compare_expressions (ptr, top_estack))
			{
				push_END_TAG();//end, y2, y1, -, x2, x1, -, div
				push_parse_text (y2value);
				push_parse_text (y1value);
				push_quantum (SUB_TAG);
				push_parse_text (x2value);
				push_parse_text (x1value);
				push_quantum_pair (SUB_TAG, DIV_TAG);
				ptr = top_estack;
				NG_rationalESI (top_estack);
				Parms2D (Parse2DExpr (top_estack, 1), &width, &bottom, &top);
				WinClr (DeskTop);
				Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 20 + top);
				NG_approxESI (ptr);
				size = top + bottom;
				Parms2D (Parse2DExpr (top_estack, 1), &width, &bottom, &top);
				Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
					22 + size + top);
			}
			else
			{
				FontSetSys (ti92plus);
				DrawStr ((lcd_width - DrawStrWidth ("No slope", ti92plus))/2,
					24 + extrawidth, "No slope", A_REPLACE);
			}
			ngetchx();
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (DIST):
		if (DialogDo (dialoghandle, CENTER, 30 + 2 * ti92plus, rawvalues, NULL)
			== KEY_ENTER)
		{
			x1value = rawvalues;
			y1value = rawvalues + 20;
			x2value = rawvalues + 40;
			y2value = rawvalues + 60;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
			push_END_TAG();//2, x1, x2, -, ^, 2, y1, y2, -, ^, +, SQRT
			push_longint (2);
			push_parse_text (x1value);
			push_parse_text (x2value);
			push_quantum_pair (SUB_TAG, POW_TAG);
			push_longint (2);
			push_parse_text (y1value);
			push_parse_text (y2value);
			push_quantum_pair (SUB_TAG, POW_TAG);
			push_quantum_pair (ADD_TAG, SQRT_TAG);
			ptr = top_estack;//save position for later, so don't have to repush all
			NG_rationalESI (top_estack);
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			size = top + bottom;
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 30 + top);
			NG_approxESI (ptr);
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
				30 + top + size + 3);
			ngetchx();
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (MID):
		if (DialogDo (dialoghandle, CENTER, 30 + 2 * ti92plus, rawvalues, NULL)
			== KEY_ENTER)
		{
			x1value = rawvalues;
			y1value = rawvalues + 20;
			x2value = rawvalues + 40;
			y2value = rawvalues + 60;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
			push_END_TAG();//end, x1, x2, +, 2, div, x, =
			push_parse_text (x1value);
			push_parse_text (x2value);
			push_quantum (ADD_TAG);
			push_longint ((long)2);
			push_quantum_pair (DIV_TAG, VAR_X_TAG);
			push_quantum (EQ_TAG);
			ptr = top_estack;
			NG_rationalESI (top_estack);
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 30 + top);
			size = top + bottom;
			NG_approxESI (ptr);
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
				30 + top + size + 3);
			size += top + bottom;
			push_END_TAG();//end, y1, y2, +, 2, div, y, =
			push_parse_text (y1value);
			push_parse_text (y2value);
			push_quantum (ADD_TAG);
			push_longint ((long)2);
			push_quantum_pair (DIV_TAG, VAR_Y_TAG);
			push_quantum (EQ_TAG);
			ptr = top_estack;
			NG_rationalESI (top_estack);
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
				30 + top + size + 6);
			NG_approxESI (ptr);
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			size += top + bottom;
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
				30 + top + size + 9);
			ngetchx();
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (CONVERT):
		sprintf (rpn, "%c%c%c%c%c%c%c%c%c%c%c", END_TAG, VAR_C_TAG, VAR_A_TAG,
				VAR_X_TAG, MUL_TAG,	VAR_B_TAG, VAR_Y_TAG, MUL_TAG, ADD_TAG, EQ_TAG,
				0);
		NG_rationalESI (rpn + strlen (rpn) - 1);
		Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
		size = top + bottom;
		Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 20 + top);
		dialoghandle = DialogNewSimple (140 + 2 * extrawidth, 54 + extrawidth);
		DialogAddRequest (dialoghandle, 1, 14, "a=", 0, 19, 8);
		DialogAddRequest (dialoghandle, 1, 24 + 2 * ti92plus, "b=", 20, 39, 8);
		DialogAddRequest (dialoghandle, 1, 34 + 4 * ti92plus, "c=", 40, 59, 8);
		DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
		if (DialogDo (dialoghandle, CENTER, 20 + size + 3, rawvalues, NULL) ==
			KEY_ENTER)
		{
			avalue = rawvalues;
			bvalue = rawvalues + 20;
			cvalue = rawvalues + 40;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
			push_END_TAG();
			push_quantum (VAR_Y_TAG);
			push_parse_text (cvalue);
			push_parse_text (avalue);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_parse_text (bvalue);
			push_quantum_pair (VAR_Y_TAG, MUL_TAG);
			push_quantum_pair (ADD_TAG, EQ_TAG);
			push_quantum (SOLVE_TAG);
			ptr = top_estack;
			NG_rationalESI (ptr);
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
				23 + size + top);
			size += bottom + top;
			NG_approxESI (ptr);
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
				26 + size + top);
			ngetchx();
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	case (EQUATION):
		if (DialogDo (dialoghandle, CENTER, 30 + 2 * ti92plus, rawvalues, NULL)
			== KEY_ENTER)
		{
			x1value = rawvalues;
			y1value = rawvalues + 20;
			x2value = rawvalues + 40;
			y2value = rawvalues + 60;
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
			push_END_TAG();//end, (y2, y1, -, x2, x1, -, /, m, =), (y1, y, =), and,
			push_parse_text (y2value);
			push_parse_text (y1value);
			push_quantum (SUB_TAG);
			push_parse_text (x2value);
			push_parse_text (x1value);
			push_quantum_pair (SUB_TAG, DIV_TAG);
			push_quantum_pair (VAR_M_TAG, EQ_TAG);
			push_parse_text (y1value);
			push_quantum_pair (VAR_Y_TAG, EQ_TAG);
			push_quantum (AND_TAG);
			push_parse_text (x1value);
			push_quantum_pair (VAR_X_TAG, EQ_TAG);
			push_quantum_pair (AND_TAG, VAR_B_TAG);
			push_quantum_pair (VAR_Y_TAG, VAR_M_TAG);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_quantum_pair (VAR_B_TAG, ADD_TAG);
			push_quantum_pair (EQ_TAG, SOLVE_TAG);
			push_quantum (WITH_TAG);
			NG_rationalESI (top_estack);//y2, y1, -, x2, x1, -, /, m, =, and, m, x,
			push_parse_text (y2value);
			push_parse_text (y1value);
			push_quantum (SUB_TAG);
			push_parse_text (x2value);
			push_parse_text (x1value);
			push_quantum_pair (SUB_TAG, DIV_TAG);
			push_quantum_pair (VAR_M_TAG, EQ_TAG);
			push_quantum_pair (AND_TAG, VAR_M_TAG);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_quantum_pair (VAR_B_TAG, ADD_TAG);
			push_quantum_pair (VAR_Y_TAG, EQ_TAG);
			push_quantum (WITH_TAG);
			ptr = top_estack;
			NG_rationalESI (top_estack);			
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 30 + top);
			size = top + bottom;
			NG_approxESI (ptr);			
			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
			Print2DExpr (top_estack,DeskTop,(lcd_width - width)/2, 32 + top + size);
			ngetchx();
		}
		else
		{
			HeapFree (dialoghandle);
			dialoghandle = H_NULL;
		}
		break;
	}
	if (dialoghandle)
	{
		HeapFree (dialoghandle);
		dialoghandle = H_NULL;
	}
}
