// C Source File
// Created 8/15/2001; 10:53:18 PM
//to handle results if it is in the parabola section
#include "declerations.h"

void push_discrim (char* avalue, char* bvalue, char* cvalue);
void parabhand (int result, LCD_BUFFER buffer)//to handle if result is for 
{//parabolas
	int width, bottom, top, size, extrawidth, top2, bottom2;
	ESI ptr, ptr2, modenamea, modenameb, quadpos, quadneg;
	HANDLE dialoghandle = H_NULL;
	unsigned char rpnnotation[100] = {END_TAG,//end, a, 2, x, ^, *, b, x, *, c,
		VAR_A_TAG, 2, 1, POSINT_TAG, VAR_X_TAG, POW_TAG, MUL_TAG,//+, +
		VAR_B_TAG, VAR_X_TAG, MUL_TAG,	VAR_C_TAG, ADD_TAG, ADD_TAG};
	char rawvalue[60] = {};
	char* avalue, *bvalue, *cvalue;
	char* currentmode;
	char* dispmode;
	int lcd_width = LCD_WIDTH, ti92plus = TI92PLUS;
	LCD_restore (buffer);//restore the background
	WinClr (DeskTop);//clear the background
	if (TI89)
	{
		extrawidth = 0;
	}
	else
	{
		extrawidth = 10;
	}
	dialoghandle = DialogNewSimple (125 + 4 * extrawidth, 54 + extrawidth);
	NG_rationalESI (rpnnotation + 13);//evaluate the expression at rpnnotation
	Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom, &top);
	Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 20 + top);
	size = top + bottom;
	DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  DialogAddRequest (dialoghandle, 3, 14, "a=", 0, 19, 8);
  DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus, "b=", 20, 19, 8);
  DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "c=", 40, 19, 8);
	switch (result)
	{
	case (X_ICEPT):
		if (DialogDo (dialoghandle, CENTER, 25 + size, rawvalue, NULL) ==
  		KEY_ENTER)
  	{
  		avalue = rawvalue;
  		bvalue = rawvalue+20;
  		cvalue = rawvalue+40;
  		HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  		push_string ($(RECTANGULAR));//push modesettingstring
  		modenameb = top_estack;//save that position
			push_whole_string ("Complex Format");//push modenamestring
			modenamea = top_estack;//save position
			push_setmode (modenamea, modenameb);//set mode
			ptr = top_estack;//save top of estack
			currentmode = GetStrnArg (ptr);//get the name of current mode
			push_whole_string ("Display Digits");
			modenamea = top_estack;
			push_whole_string ("FLOAT 12");
			modenameb = top_estack;
			push_setmode (modenamea, modenameb);
			ptr = top_estack;
			dispmode = GetStrnArg (ptr);
			ptr = top_estack;
			push_END_TAG();//end, discrim, sqrt_tag
			push_parse_text (bvalue);
			push_quantum (MINUS_TAG);
  		push_discrim (avalue, bvalue, cvalue);
  		push_quantum_pair (SQRT_TAG, ADD_TAG);
  		push_longint ((long)2);
  		push_parse_text (avalue);
  		push_quantum_pair (MUL_TAG, DIV_TAG);
  		push_quantum_pair (VAR_X_TAG, EQ_TAG);
  		quadpos = top_estack;
  		NG_rationalESI (top_estack);
  		Parms2D ((ptr = Parse2DExpr (top_estack, TRUE)), &width, &bottom,
  			&top);
			WinClr (DeskTop);
			FontSetSys (F_6x8);
			Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, top + 20);
			ptr = top_estack;	
			push_END_TAG();//end, discrim, sqrt_tag
			push_parse_text (bvalue);
			push_quantum (MINUS_TAG);
  		push_discrim (avalue, bvalue, cvalue);
  		push_quantum_pair (SQRT_TAG, SUB_TAG);
  		push_longint ((long)2);
  		push_parse_text (avalue);
  		push_quantum_pair (MUL_TAG, DIV_TAG);
  		push_quantum_pair (VAR_X_TAG, EQ_TAG);
  		quadneg = top_estack;
			NG_rationalESI (top_estack);
			Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom2,
  			&top2);
  		Print2DExpr (ptr, DeskTop, (lcd_width - width)/2,
  			top + 22 + bottom + top2);
			ngetchx();//end, -b, discrim, SQRT_T
			NG_approxESI (quadpos);
			Parms2D ((ptr = Parse2DExpr (top_estack, TRUE)), &width, &bottom,
				&top);
			WinClr (DeskTop);
			Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, top + 20);
			ptr = top_estack;	
			NG_approxESI (quadneg);
			Parms2D ((ptr = Parse2DExpr (top_estack, TRUE)), &width, &bottom2,
				&top2);
			Print2DExpr (ptr, DeskTop, (lcd_width - width)/2,
  			top + 22 + bottom + top2);
		 	ngetchx();
			push_whole_string ("Complex Format");
  		modenamea = top_estack;
  		push_ANSI_string (currentmode);
  		modenameb = top_estack;
  		push_setmode (modenamea, modenameb);
  		push_whole_string ("Display Digits");
  		modenamea = top_estack;
  		push_whole_string (dispmode);
  		modenameb = top_estack;
  		push_setmode (modenamea, modenameb);
  	}
  	else
  	{
  		HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  	}
		break;
	case (VERTEX):
		if (DialogDo (dialoghandle, CENTER, 25 + size, rawvalue, NULL) ==
  		KEY_ENTER)
		{
  		avalue = rawvalue;
  		bvalue = rawvalue+20;
  		cvalue = rawvalue+40;
  		HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  		push_END_TAG();
 			push_parse_text (bvalue);
			push_quantum (MINUS_TAG);
			push_longint ((long)2);
			push_parse_text (avalue);
			push_quantum_pair (MUL_TAG, DIV_TAG);
			push_quantum_pair (VAR_X_TAG, EQ_TAG);
			ptr = top_estack;//x, -b, 2, a, *, /, =, a, x, 2, ^, *, b, x, *, +, c,
			push_parse_text (avalue);
			push_longint ((long)2);
			push_quantum_pair (VAR_X_TAG, POW_TAG);
			push_quantum (MUL_TAG);
			push_parse_text (bvalue);
			push_quantum_pair (VAR_X_TAG, MUL_TAG);
			push_quantum (ADD_TAG);
			push_parse_text (cvalue);
			push_quantum_pair (ADD_TAG, WITH_TAG);
			push_quantum_pair (VAR_Y_TAG, EQ_TAG);
			quadneg = top_estack;//just reusing variables
			NG_rationalESI (top_estack);
			ptr2 = top_estack;
			NG_rationalESI (ptr);
			quadpos = ptr;
			ptr = top_estack;
			Parms2D ((ptr = Parse2DExpr (ptr, TRUE)), &width, &bottom, &top);
			WinClr (DeskTop);
			Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, top + 20);
			Parms2D ((ptr2 = Parse2DExpr (ptr2, FALSE)), &width, &bottom2, &top2);
			Print2DExpr (ptr2, DeskTop,	(lcd_width - width)/2,
				top + 22 + bottom + top2);
			ngetchx();
			WinClr (DeskTop);
			NG_approxESI (quadpos);
			ptr2 = top_estack;
			NG_approxESI (quadneg);
			ptr = top_estack;
			Parms2D ((ptr = Parse2DExpr (ptr, TRUE)), &width, &bottom, &top);
			WinClr (DeskTop);
			Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, top + 20);
			Parms2D ((ptr2 = Parse2DExpr (ptr2, FALSE)), &width, &bottom2, &top2);
			Print2DExpr (ptr2, DeskTop,	(lcd_width - width)/2,
				top + 22 + bottom + top2);
		 	ngetchx();
  	}
  	else
  	{
  		HeapFree (dialoghandle);
  		dialoghandle = H_NULL;
  	}
		break;
	}
	if (dialoghandle)
	{
		HeapFree (dialoghandle);
		dialoghandle = H_NULL;
	}
}

void push_discrim (char* avalue, char* bvalue, char* cvalue)//to push the disc
{
	push_longint ((long)2);
	push_parse_text (bvalue);
	push_quantum (POW_TAG);
	push_longint ((long)4);
	push_parse_text (avalue);
	push_parse_text (cvalue);
	push_quantum_pair (MUL_TAG, MUL_TAG);
	push_quantum (SUB_TAG);
}
