// C Source File
// Created 4/11/2002; 9:33:09 PM
#include "declerations.h"
enum {TERM = 1, SUM = 2, INFSUM = 3};
void serhand (int result)
{
	int lcd_width = LCD_WIDTH, ti92plus = TI92PLUS;
	HANDLE dialoghandle = H_NULL, popuphandle = H_NULL;
	int extrawid = 0, width, bottom, top, bottom2, top2;
	ESI ptr;
	popuphandle = PopupNew ("Which One?", 0);
	PopupAddText (popuphandle, -1, "Nth Term", TERM);
	PopupAddText (popuphandle, -1, "Sum", SUM);
	char rawvalues [60], *term, *fterm, *dterm;
	WinClr (DeskTop);
	if (ti92plus)
	{
		extrawid = 10;
	}
	if (result == ARITHMETIC)
	{
		if (!(result = PopupDo (popuphandle, CENTER, CENTER, 0)))
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			return;
		}
		if (result == TERM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus,
  			"Difference", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "Which Term", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//a1+d(n-1)
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			term = rawvalues + 40;
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;
 			push_parse_text (term);
 			push_longint ((long)1);
 			push_quantum (SUB_TAG);
 			push_parse_text (dterm);
 			push_quantum (MUL_TAG);
 			push_parse_text (fterm);
 			push_quantum (ADD_TAG);
 			ptr = top_estack;
 			NG_rationalESI (top_estack);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 22 + top);
 			NG_approxESI (ptr);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom2, &top2);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
 				25 +  top + bottom + top2);
 			ngetchx();
		}
		else if (result == SUM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2 * ti92plus,
  			"Last Term", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "How many", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//n(n1+nn)/2=term(fterm + dterm)/2
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			term = rawvalues + 40;
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;
 			push_parse_text (fterm);
 			push_parse_text (dterm);
 			push_quantum (ADD_TAG);
 			push_parse_text (term);
 			push_quantum (MUL_TAG);
 			push_longint ((long)2);
 			push_quantum (DIV_TAG);
 			ptr = top_estack;
 			NG_rationalESI (top_estack);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 22 + top);
 			NG_approxESI (ptr);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom2, &top2);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
 				25 +  top + bottom + top2);
 			ngetchx();
		}		
	}
	else if (result == GEOMETRIC)
	{
		PopupAddText (popuphandle, -1, "Infinite Sum", INFSUM);
		if (!(result = PopupDo (popuphandle, CENTER, CENTER, 0)))
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			return;
		}
		if (result == SUM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus, "Ratio", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "How Many", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			term = rawvalues + 40;
 			//a1(1-r^n)/(1-r)=fterm(1-dterm^term)/(1-term)
 			push_longint ((long)1);
 			push_parse_text (term);
 			push_parse_text (dterm);
 			push_quantum_pair (POW_TAG, SUB_TAG);
 			push_parse_text (fterm);
 			push_quantum (MUL_TAG);
 			push_longint ((long)1);
 			push_parse_text (dterm);
 			push_quantum_pair (SUB_TAG, DIV_TAG);
 			ptr = top_estack;
 			NG_rationalESI (top_estack);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 22 + top);
 			NG_approxESI (ptr);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom2, &top2);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
 				25 +  top + bottom + top2);
 			ngetchx();
		}
		else if (result == TERM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus,	"Ratio", 20, 19, 8);
 			DialogAddRequest (dialoghandle, 3, 34 + 4 * ti92plus, "Which Term", 40,
 				19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//a1*r^(n-1) = fterm*dterm^(term - 1)
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			term = rawvalues + 40;
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;
 			push_parse_text (term);
 			push_longint ((long)1);
 			push_quantum (SUB_TAG);
 			push_parse_text (dterm);
 			push_quantum (POW_TAG);
 			push_parse_text (fterm);
 			push_quantum (MUL_TAG);
 			ptr = top_estack;
 			NG_rationalESI (top_estack);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 22 + top);
 			NG_approxESI (ptr);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom2, &top2);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
 				25 +  top + bottom + top2);
 			ngetchx();
		}
		else if (result == INFSUM)
		{
			HeapFree (popuphandle);
			popuphandle = H_NULL;
			dialoghandle = DialogNewSimple (125 + 4 * extrawid, 54 + extrawid);
			DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
  		DialogAddRequest (dialoghandle, 3, 14, "First Term", 0, 19, 8);
  		DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus,	"Ratio", 20, 19, 8);
 			if (DialogDo (dialoghandle, CENTER, CENTER, rawvalues, NULL)
 				!= KEY_ENTER)
 			{
 				HeapFree (dialoghandle);
 				dialoghandle = H_NULL;
 				return;
 			}
 			//a1/(1-r)=fterm/(1-dterm)
 			fterm = rawvalues;
 			dterm = rawvalues + 20;
 			HeapFree (dialoghandle);
 			dialoghandle = H_NULL;
 			push_parse_text (fterm);
 			push_longint ((long)1);
 			push_parse_text (dterm);
 			push_quantum_pair (SUB_TAG, DIV_TAG);
 			ptr = top_estack;
 			NG_rationalESI (top_estack);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2, 22 + top);
 			NG_approxESI (ptr);
 			Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom2, &top2);
 			Print2DExpr (top_estack, DeskTop, (lcd_width - width)/2,
 				25 +  top + bottom + top2);
 			ngetchx();
		}
	}
	if (dialoghandle)
	{
		HeapFree (dialoghandle);
		dialoghandle = 0;
	}
	if (popuphandle)
	{
		HeapFree (popuphandle);
		popuphandle = 0;
	}
}
